<?php
namespace Planejamento\Repositories;

class Embdistcard extends \Doctrine\ORM\EntityRepository
{
    public static function RetornaNrembdistcardEmbalagens(){
       $nrdistcard = tk_get_context_vars('NRDISTCARD','tab_pla15400_000_001_filter');

        $sql = <<<SQL
SELECT E.NREMBDISTCARD FROM EMBDISTCARD E
    LEFT JOIN CONTAINER C ON E.CDCONTAINER = C.CDCONTAINER
    WHERE NRDISTCARD =:NRDISTCARD AND C.IDPROPOSITO ='I'
SQL;
        $params = array(
            'NRDISTCARD' =>$nrdistcard);

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
        $sql = $sql[0];
        if($sql){
            $nremb = $sql;
        }else{
            $nremb = false;
        }
        return $nremb;
     }

    public static function RetornaEmbalagensRelatorio($filiais,$grupos,$nrlista,$clientes,$dtini,$dtfin,$catogorias,$embalagens,
                $cdpratoini,$cdpratofin,$idproposito){
        $sql = <<<SQL
SELECT DISTINCT E.NREMBDISTCARD, E.QTCONTAINER
FROM CARDADIA C
	INNER JOIN FILIAL F ON F.CDFILIAL = C.CDFILIAL
	INNER JOIN DISTCARD D ON D.CDFILIAL = C.CDFILIAL AND
							 D.NRCARDAPIO = C.NRCARDAPIO
	INNER JOIN SERVICO S ON S.CDFILIAL = C.CDFILIAL AND
							S.CDSERVFILI = C.CDSERVFILI
	LEFT JOIN DESTSRVCLI DC ON DC.CDFILIAL = S.CDFILIAL AND
                                   DC.CDSERVFILI = S.CDSERVFILI AND
                                   DC.CDCLIENTE = D.CDCLIENTE AND
				   DC.CDDESTFILI = D.CDDESTFILI
	LEFT JOIN CLIENTE CLI ON CLI.CDCLIENTE = DC.CDCLIENTE
	LEFT JOIN DESTFILI DF ON DF.CDDESTFILI = DC.CDDESTFILI AND DF.CDFILIAL = DC.CDFILIAL
	INNER JOIN ITEMBDISTCARD I ON I.NRDISTCARD = D.NRDISTCARD
	INNER JOIN EMBDISTCARD E ON E.NREMBDISTCARD = I.NREMBDISTCARD
	INNER JOIN CONTAINER EMB ON EMB.CDCONTAINER = E.CDCONTAINER
	INNER JOIN CNFDISTCARD CNF ON CNF.NRDISTCARD = D.NRDISTCARD AND
								  CNF.NRSEQPRATCAR = I.NRSEQPRATCAR
	INNER JOIN PRATO P ON P.CDFILAUXPRAT = CNF.CDFILAUXPRAT AND
						  P.CDPRATO = CNF.CDPRATO
        LEFT JOIN RELPRATEMB R ON R.CDFILAUXPRAT = P.CDFILAUXPRAT AND
                                  R.CDPRATO = P.CDPRATO AND
                                  R.CDCONTAINER = EMB.CDCONTAINER
	LEFT JOIN LISTA LS ON LS.NRLISTA = :P_NRLISTASERV AND
						  S.CDFILIAL || S.CDSERVFILI = LS.CDLISTA
WHERE ((:P_FILIAIS = 'T') OR (INSTR(:P_FILIAIS, '_' || C.CDFILIAL || '_') <> 0))
  AND ((:P_GRUPOS = 'T') OR (INSTR(:P_GRUPOS, '_' || S.CDGRUPSERV || '_') <> 0))
  AND ((:P_NRLISTASERV = 'T') OR (LS.CDLISTA IS NOT NULL))
  AND ((:P_CLIENTES = 'T') OR (INSTR(:P_CLIENTES, '_' || CLI.CDCLIENTE || '_') <> 0))
  AND (C.DTCARDAPIO BETWEEN :P_DTINI AND :P_DTFIN)
  AND ((:P_CATEGORIAS = 'T') OR (INSTR(:P_CATEGORIAS, '_' || TO_CHAR(EMB.NRCATEMBALAG) || '_') <> 0))
  AND ((:P_EMBALAGENS = 'T') OR (INSTR(:P_EMBALAGENS, '_' || EMB.CDCONTAINER || '_') <> 0))
  AND ((:P_PRATOINI = 'T') OR (P.CDPRATO BETWEEN :P_PRATOINI AND :P_PRATOFIN || 'zzzzzzzzzz'))
  AND (EMB.IDPROPOSITO = :P_PROPOSITO)
SQL;
        $params = array(
            'P_FILIAIS'     =>$filiais,
            'P_GRUPOS'   =>$grupos,
            'P_NRLISTASERV' => $nrlista,
            'P_CLIENTES' => $clientes,
            'P_DTINI' => $dtini,
            'P_DTFIN' => $dtfin,
            'P_CATEGORIAS' => $catogorias,
            'P_EMBALAGENS' => $embalagens,
            'P_PRATOINI' => $cdpratoini,
            'P_PRATOFIN' => $cdpratofin,
            'P_PROPOSITO'=> $idproposito

        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }
}