/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CDBARRAPROD                                              */
/* Tabela : CDBARRAPROD                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 27/11/2004 - Ronaldo Amaral Costa                                          */
/*                                                                            */
/******************************************************************************/


CREATE OR REPLACE TRIGGER DTULTATU_CDBARRAPROD
BEFORE INSERT OR UPDATE OR DELETE
ON CDBARRAPROD FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCBAP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDBARRAPROD,0) <> NVL(:NEW.CDBARRAPROD,0))   OR
         (NVL(:OLD.CDPRODUTO,0)   <> NVL(:NEW.CDPRODUTO,0))     THEN
         :NEW.DTULTATUCBAP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CDBARRAPROD','', 'CDBARRAPROD='||:OLD.CDBARRAPROD||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CDBARRAPROD MODIFY DTULTATUCBAP DEFAULT SYSDATE
/

